
object RealDataExp extends App {
  println("reading in graph")
  val gFile = args(0)
  val l = args(1).toInt
  val qFile = "enquery.txt"
  val g = Graph(gFile)
  val name = "" //TODO
  println("done reading graph")
  println("n vertices: " + g.size + "n edges: " + g.nEdges)
  println("generating query")
  for (i <- 0 until 10) {
    var q = GraphGenerator.generateBFSQuery(25, 2, g)
    q.writeToFile(qFile)
    println("done generating query")
    println("n vertices: " + q.size + "n edges: " + q.nEdges)

    Utils.runAllExps(g, q, gFile, qFile, name)

    q = GraphGenerator.generateRandomGraph(25, l, 2)
    q.writeToFile(qFile)
    println("done generating query")
    println("n vertices: " + q.size + "n edges: " + q.nEdges)

    Utils.runAllExps(g, q, gFile, qFile, name)

  }
}

object ExtractQueryExp extends App {
  println("generating graph")
  val g = GraphGenerator.generateRandomGraph(1000000, 20, 16)
  println("done generating graph")
  println("n vertices: " + g.size + "n edges: " + g.nEdges)
  println("generating query")
  for (i <- 0 until 10) {
    val q = GraphGenerator.extractSubgraph(10000, g)
    q.writeToFile("enquery.txt")
    println("done generating query")
    println("n vertices: " + q.size + "n edges: " + q.nEdges)

    //Utils.simpleExp(g, q, "enwiki")
    //Utils.dualExp(g, q, "enwiki")
//    Utils.saltzOptExp(g, q, "enwiki")
//    Utils.saltzSimpleExp(g, q, "enwiki")
//    Utils.saltzExp(g, q, "enwiki")
    //Utils.vf2Exp("enwiki-2013-0.txt", "enquery.txt")
  }
}

object SimpleVsDualTimeExp extends App {
  println("generating graph")
  val gFile = "svdtg"
  val qFile = "svdtq"
  val g = GraphGenerator.generateRandomGraph(20, 1, 6)
  g.writeToFile(gFile)
  println("done generating graph")
  println("n vertices: " + g.size + "n edges: " + g.nEdges)
  println("generating query")
  for (i <- 0 until 10) {
    var q =  GraphGenerator.generateRandomGraph(20, 1, 2)//GraphGenerator.generateBFSQuery(25, 2, g)
    q.writeToFile(qFile)
    println("done generating query")
    println("n vertices: " + q.size + "n edges: " + q.nEdges)

    Utils.runAllExps(g, q, gFile, qFile, "test,bla,poo")
    println("BFS")
    q =  GraphGenerator.generateBFSQuery(20, 2, g)
    q.writeToFile(qFile)
    println("done generating query")
    println("n vertices: " + q.size + "n edges: " + q.nEdges)

    Utils.runAllExps(g, q, gFile, qFile, "test,bla,poo")

  }
}

object SimpleVsDualQualExp extends App {
  println("generating graph")
  val g = Graph("us_gl.txt", "us_ge.txt")
  println("done generating graph")
  println("n vertices: " + g.size + "n edges: " + g.nEdges)
  println("generating query")
  val q = Graph("us_ql.txt", "us_qe.txt")
  q.writeToFile("enquery.txt")
  println("done generating query")
  println("n vertices: " + q.size + "n edges: " + q.nEdges)
  println("graph sim")
  PatternMatcher.saltzGraphSim(g, q).foreach(println(_))
  println("dual sim")
  PatternMatcher.saltzDualSim(g, q).foreach(println(_))

}

object TimeoutTest extends App { 
  val g = GraphGenerator.generateRandomGraph(10000, 1, 16)
  g.writeToFile("ttg")
  val q = GraphGenerator.generateBFSQuery(10, 2, g)
  q.writeToFile("ttq")
  Utils.vf2Exp("ttg", "ttq")
  Utils.dualExp(g, q, "dualisotimetest")
}
object DualIsoTimeTest extends App {
  val g = GraphGenerator.generateRandomGraph(1000000, 100, 16)
  val q = GraphGenerator.generateBFSQuery(10, 2, g)
  Utils.saltzExpWithDualExp(g, q, "dualisotimetest")
  Utils.dualExp(g, q, "dualisotimetest")
}
