
object PajekReaderTest extends App {
  if (args.length != 2) {
    println("usage: <labelFile> <edgeFile>")
    System.exit(-1)
  }

  val g = Graph.readFromPajekFile(args(0), args(1))
  println("size: " + g.size)
  println("nEdges: " + g.nEdges)
  g.labelMap.foreach{ case (label, nodes) => 
    println("Label " + label + " has " + nodes.size + " nodes") 
  }
}

object PajekBasicTest extends App {
  if (args.length != 2) {
    println("usage: <labelFile> <edgeFile>")
    System.exit(-1)
  }
  val g = Graph.readFromPajekFile(args(0), args(1))
  println("size: " + g.size)
  println("nEdges: " + g.nEdges)
  g.labelMap.foreach{ case (label, nodes) => 
    println("Label " + label + " has " + nodes.size + " nodes") 
  }

  (0 until 10).foreach { _ =>
    val q = GraphGenerator.generateBFSQuery(10, 1, g)
    Utils.runAllMyExpsCapped(g, q,"pbg.txt", "pbq.txt", 1024, "pajek")
  }
}

object PajekRandomTest extends App {
  if (args.length != 2) {
    println("usage: <labelFile> <edgeFile>")
    System.exit(-1)
  }
  val g = Graph.readFromPajekFile(args(0), args(1))
  val querySizes = (5 to 15)
  (0 until 1000).foreach { rep =>
      querySizes.foreach {qSize => 
        val q = GraphGenerator.generateRandomConnectedGraph(qSize, g.nLabels, 2)
        Utils.runAllMyExpsCapped(g, q,"pbg.txt", "pbq.txt", 1024, qSize + "_" +
          rep + "_" + args(1))
      }
  }
}

object PajekBFSTest extends App {
  if (args.length != 2) {
    println("usage: <labelFile> <edgeFile>")
    System.exit(-1)
  }
  val g = Graph.readFromPajekFile(args(0), args(1))
  val querySizes = (3 to 10)
  (0 until 1000).foreach { rep =>
      querySizes.foreach {qSize => 
        val q = GraphGenerator.generateBFSQuery(qSize, 2, g)
        Utils.runAllMyExpsCapped(g, q,"pbg.txt", "pbq.txt", 1024, qSize + "_" +
          rep + "_" + args(1))
      }
  }
}
