
object VaryDensityRandGraph extends App {
  val gSize = 1000000
  val qSize = 10
  val qDegree = 2
  val nLabels = 100
  val gFile = "vdrgg"
  val qFile = "vdrgq"

  val degrees = Set(10, 20, 30, 40, 50, 60, 70, 80, 90, 100)
  val nGraphs = (0 until 5)
  val queryReps = (0 until 10)

  for (n <- nGraphs) {
    for (deg <- degrees) {
      val g = GraphGenerator.generateRandomGraph(gSize, nLabels, deg)
      g.writeToFile(gFile)
      for (qRep <- queryReps) {
        val q = GraphGenerator.generateBFSQuery(qSize, qDegree, g)
        q.writeToFile(qFile)
        Utils.runAllExps(g, q, gFile, qFile, deg + "_" + n + "_" + qRep)
      }
    }
  }
}

object VaryDensityRandGraphFast extends App {
  val gSize = 1000000
  val qSize = 10
  val qDegree = 2
  val nLabels = 100
  val gFile = "vdrgg"
  val qFile = "vdrgq"

  val degrees = Set(10, 20, 30, 40, 50, 60, 70, 80, 90, 100)
  val nGraphs = (0 until 5)
  val queryReps = (0 until 10)

  for (n <- nGraphs) {
    for (deg <- degrees) {
      val g = GraphGenerator.generateRandomGraph(gSize, nLabels, deg)
      g.writeToFile(gFile)
      for (qRep <- queryReps) {
        val q = GraphGenerator.generateBFSQuery(qSize, qDegree, g)
        q.writeToFile(qFile)
        Utils.runAllFastExps(g, q, gFile, qFile, deg + "_" + n + "_" + qRep)
      }
    }
  }
}

