import sys.process._
import scala.language.postfixOps

object VaryVqSmallBFS extends App {
  val l = 100 
  val nQueries = 0 until 10
  val nGraphs = 0 until 5
  val querySizes = Array(2, 4, 6, 8, 10, 12, 14, 16, 18, 20) 
  val queryAvDegree = 2
  val graphSize = 1000000
  val graphAvDegree = 16 
  val gFile = "vqgsmallbfs.txt" 
  val qFile = "vqqsmallbfs.txt"

  for (r <- nGraphs) {
    var g = GraphGenerator.generateRandomConnectedGraph(graphSize, l, graphAvDegree)
    g.writeToFile(gFile)

    for (qRep <- nQueries) {
      for (vq <- querySizes) {
        val name = vq+"_BFS_"+r+"_"+qRep
        var q = GraphGenerator.generateBFSQuery(vq, queryAvDegree, g)
        q.writeToFile(qFile)
        Utils.runAllExps(g, q, gFile, qFile, name)
      }
    }
  }
  println("FINISHED!  WOOHOO!")
}

object VaryVqSmallRand extends App {
  val l = 100 
  val nQueries = 0 until 10
  val nGraphs = 0 until 5
  val querySizes = Array(2, 4, 6, 8, 10, 12, 14, 16, 18, 20) 
  val queryAvDegree = 2
  val graphSize = 1000000
  val graphAvDegree = 16 
  val gFile = "vqgsmallrand.txt" 
  val qFile = "vqqsmallrand.txt"

  for (r <- nGraphs) {
    var g = GraphGenerator.generateRandomConnectedGraph(graphSize, l, graphAvDegree)
    g.writeToFile(gFile)

    for (qRep <- nQueries) {
      for (vq <- querySizes) {
        val name = vq+"_rand_"+r+"_"+qRep
        var q = GraphGenerator.generateRandomConnectedGraph(vq, l, queryAvDegree)
        q.writeToFile(qFile)
        Utils.runAllExps(g, q, gFile, qFile, name)
      }
    }
  }
  println("FINISHED!  WOOHOO!")
}

object VaryVqLargeBFSFast extends App {
  val l = 100
  val nQueries = 0 until 10
  val nGraphs = 0 until 5
  val querySizes = Array(20, 40, 60, 80, 100) 
  val queryAvDegree = 2
  val graphSize = 1000000
  val graphAvDegree = 16 
  val gFile = "vqglargebfsfast.txt"
  val qFile = "vqqlargebfsfast.txt"

    //println("QUERY SIZE: " + vq)
  for (r <- nGraphs) {
    //println("Generating rand graph...")
    var g = GraphGenerator.generateRandomConnectedGraph(graphSize, l, graphAvDegree)
    g.writeToFile(gFile)
    //println("Done generating rand graph...")

    for (qRep <- nQueries) {
      for (vq <- querySizes) {
        val name = vq+"_BFS_"+r+"_"+qRep
        //println("Generating query graph...")
        var q = GraphGenerator.generateBFSQuery(vq, queryAvDegree, g)
        q.writeToFile(qFile)
        //println("Done generating query...")
        Utils.runAllFastExps(g, q, gFile, qFile, name)
      }
    }
  }

  println("FINISHED THE EXPERIMENT WOOHOOOOOOYAY")
}

object VaryVqLargeBFS extends App {
  val l = 100
  val nQueries = 0 until 10
  val nGraphs = 0 until 5
  val querySizes = Array(20, 40, 60, 80, 100) 
  val queryAvDegree = 2
  val graphSize = 1000000
  val graphAvDegree = 16 
  val gFile = "vqglargebfs.txt"
  val qFile = "vqqlargebfs.txt"

    //println("QUERY SIZE: " + vq)
  for (r <- nGraphs) {
    //println("Generating rand graph...")
    var g = GraphGenerator.generateRandomConnectedGraph(graphSize, l, graphAvDegree)
    g.writeToFile(gFile)
    //println("Done generating rand graph...")

    for (qRep <- nQueries) {
      for (vq <- querySizes) {
        val name = vq+"_BFS_"+r+"_"+qRep
        //println("Generating query graph...")
        var q = GraphGenerator.generateBFSQuery(vq, queryAvDegree, g)
        q.writeToFile(qFile)
        //println("Done generating query...")
        Utils.runAllFastExps(g, q, gFile, qFile, name)
      }
    }
  }

  println("FINISHED THE EXPERIMENT WOOHOOOOOOYAY")
}

object VaryVqLargeRand extends App {
  val l = 100
  val nQueries = 0 until 10
  val nGraphs = 0 until 5
  val querySizes = Array(20, 40, 60, 80, 100) 
  val queryAvDegree = 2
  val graphSize = 1000000
  val graphAvDegree = 16 
  val gFile = "vqglargerand.txt"
  val qFile = "vqqlargerand.txt"

  for (r <- nGraphs) {
    var g = GraphGenerator.generateRandomConnectedGraph(graphSize, l, graphAvDegree)
    g.writeToFile(gFile)

    for (qRep <- nQueries) {
      for (vq <- querySizes) {
        val name = vq+"_rand_"+r+"_"+qRep
        var q = GraphGenerator.generateRandomConnectedGraph(vq, l, queryAvDegree)
        q.writeToFile(qFile)
        Utils.runAllExps(g, q, gFile, qFile, name)
      }
    }
  }
  println("FINISHED THE EXPERIMENT WOOHOOOOOOYAY")
}
